!!ARBfp1.0

ATTRIB iColor = fragment.color.primary;
ATTRIB iCoord = fragment.texcoord;

PARAM blurdesc = program.local[0]; # x: X scale; y: Y scale; z: intensivity;

OUTPUT oColor = result.color;

#---------#
# Program #
#---------#

# mix texture & primary color
TEMP samp;
TXP samp, iCoord, texture, 2D;

# mix samples
TEMP dest;
MOV dest, 0.0;
TEMP out;
TEMP pos;
TEMP tmp;
TEMP size;
MOV size.x, blurdesc.x;
MOV size.y, blurdesc.y;
TEMP quality;
MUL quality, 0.5, blurdesc.z;

# sample weights & sizes
TEMP sw0, sw1, sw2, sw3, sw4, sw5, sw6;
MOV sw0, 0.199471;
MOV sw1, 0.176033;
MOV sw2, 0.120985;
MOV sw3, 0.064759;
MOV sw4, 0.026995;
MOV sw5, 0.008764;
MOV sw6, 0.002216;
TEMP divi;
RCP divi.x, size.x;
RCP divi.y, size.y;
TEMP ss1, ss2, ss3, ss4, ss5, ss6;
MUL ss1, divi, 1.0;
MUL ss2, divi, 2.0;
MUL ss3, divi, 3.0;
MUL ss4, divi, 4.0;
MUL ss5, divi, 5.0;
MUL ss6, divi, 6.0;


#0
TXP tmp, iCoord, texture, 2D;
MUL tmp, tmp, sw1;
ADD dest, dest, tmp;


#1px
MOV pos.x, ss1;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw1;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#1nx
MOV pos.x, -ss1;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw1;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#1py
MOV pos.y, ss1;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw1;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#1ny
MOV pos.y, -ss1;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw1;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;


#2px
MOV pos.x, ss2;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw2;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#2nx
MOV pos.x, -ss2;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw2;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#2py
MOV pos.y, ss2;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw2;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#2ny
MOV pos.y, -ss2;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw2;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;


#3px
MOV pos.x, ss3;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw3;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#3nx
MOV pos.x, -ss3;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw3;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#3py
MOV pos.y, ss3;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw3;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#3ny
MOV pos.y, -ss3;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw3;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;


#4px
MOV pos.x, ss4;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw4;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#4nx
MOV pos.x, -ss4;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw4;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#4py
MOV pos.y, ss4;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw4;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#4ny
MOV pos.y, -ss4;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw4;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;


#5px
MOV pos.x, ss5;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw5;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#5nx
MOV pos.x, -ss5;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw5;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#5py
MOV pos.y, ss5;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw5;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#5ny
MOV pos.y, -ss5;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw5;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;


#6px
MOV pos.x, ss6;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw6;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#6nx
MOV pos.x, -ss6;
MOV pos.yzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw6;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#6py
MOV pos.y, ss6;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw6;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;
#6ny
MOV pos.y, -ss6;
MOV pos.xzw, 0.0;
ADD pos, iCoord, pos;
TXP tmp, pos, texture, 2D;
MUL tmp, tmp, sw6;
MUL tmp, tmp, quality;
ADD dest, dest, tmp;

MUL out, dest, iColor;

# set output
MOV oColor, out;

END