/*
	Name:			XenoN PlayGate Header
	Version:		1.0.0.0
	Update:			2009-10-12
	Copyright:		Copyright  2008-2009 XenoN PlayGate by PsichiX. All rights reserved.
	Author:			PsichiX
	Website:		http://www.playgate.psichix.com
	Description:	XenoN PlayGate GameMaker Engine Header
*/

/*
	== EN ==
	This file is part of Xenon PlayGate Engine.
	You may distribute it further, but you can not modify it.
	Please do not use in modified form.
	The principles of XenoN Core License available in the file LICENSE_PLAYGATE_EN.TXT.

	== PL ==
	Ten plik jest czescia XenoN PlayGate Engine.
	Mozesz go rozpowszechniac dalej, jednak nie mozesz go modyfikowac.
	Nalezy uzytkowac w nie zmodyfikowanej formie.
	Nalezy przestrzegac zasad Licencji XenoN Core dostepnej w pliku LICENSE_PLAYGATE_PL.TXT.
*/

#ifdef PG_PLUGIN
#define XE_NOT_USE_LIBRARY
#include "XenonCore.h"
using namespace XeCore;
#endif /* PG_PLUGIN */

#define PG_RES_TYPE 100000
#define PG_RES_SOLAR 100001
#define PG_RES_XENON 100002
#define PG_RES_FONT 100003
#define PG_RES_ICON_CHAOS 100004
#define PG_RES_ICON_PHOTON 100005
#define PG_RES_ICON_ECHO 100006
#define PG_RES_ICON_PSYCHE 100007
#define PG_RES_ICON_TIMEBRIDGE 100008
#define PG_RES_ICON_ETHER 100009
#define PG_RES_ICON_UNKNOWN 100010

#undef TRANSPARENT
#undef TEXT

#define _EXTENSION	(PG_ESTATE)-1
#define _SYSTEM		(PG_ESTATE)-2
#define _WINDOW		(PG_ESTATE)-3
#define _PHOTON		(PG_ESTATE)-4
#define _CHAOS		(PG_ESTATE)-5
#define _ECHO		(PG_ESTATE)-6
#define _DATA		(PG_ESTATE)-7
#define _MATH		(PG_ESTATE)-8
#define _INTERFACE	(PG_ESTATE)-9

enum PG_ESTATE
{
INITIATION,
CLOSURE,
PREPARE_TO_BE,
GET,
SET,
INFO,
LENGTHDIR_X,
LENGTHDIR_Y,
LENGTHDIR_Z,
DIRECTION_ALPHA,
DIRECTION_BETA,
DISTANCE,
CAMERA_PERSPECTIVE,
CAMERA_ORTHO,
CAMERA_TO_ORTHO,
CAMERA_GET,
CROSS_PRODUCT_X,
CROSS_PRODUCT_Y,
CROSS_PRODUCT_Z,
DOT_PRODUCT,
MATRIX,
MATRIX_MODE,
MATRIX_PUSH,
MATRIX_POP,
MATRIX_GET,
MATRIX_SET,
MATRIX_IDENTITY,
MATRIX_MULTIPLY,
MATRIX_ROTATE,
MATRIX_SCALE,
MATRIX_TRANSLATE,
MATRIX_TRANSPOSE,
MATRIX_LOAD,
VECTOR,
VECTOR_PUSH,
VECTOR_POP,
VECTOR_SET,
VECTOR_GET,
VECTOR_ADD,
VECTOR_SUB,
VECTOR_MUL,
VECTOR_DIV,
CURVE,
VIEWPORT,
UPDATE,
VSYNC,
PRIMITIVE_BEGIN,
PRIMITIVE_END,
PUT,
VERTEX,
NORMAL,
FOGVERTEX,
TEXVERTEX,
MULTITEXVERTEX,
TEXT,
TEXT_FONT,
FONT,
PREPARE_FONT,
GENERATE_FONT,
ACTIVATE_FONT,
SPRITE,
SPRITE_DRAW,
FROM_X,
FROM_Y,
FROM_Z,
TO_X,
TO_Y,
TO_Z,
UP_X,
UP_Y,
UP_Z,
X,
Y,
Z,
W,
SIGN,
WIDTH,
HEIGHT,
DEPTH,
FULLSCREEN,
SHOW,
ON_BAR,
ON_TRAY,
NAME,
ALPHA,
COLOR,
TRANSPARENT,
CREATE,
DESTROY,
CREATE_ELM,
DESTROY_ELM,
RESOURCE,
RESOURCE_LOAD_FILE,
RESOURCE_LOAD_PLAYGATE,
RESOURCE_BUFFER,
RESOURCE_FREE,
BUFFER,
BUFFER_ALLOC,
BUFFER_RELEASE,
BUFFER_SIZE,
BUFFER_POINTER,
SIZEOF,
T_BOOL,
T_BYTE,
T_UBYTE,
T_SHORT,
T_USHORT,
T_INT,
T_UINT,
T_LONG,
T_ULONG,
T_FLOAT,
T_DOUBLE,
T_POINTER,
ENCODE,
DECODE,
PACK,
UNPACK,
RENDER_TARGET_ACTIVATE,
RENDER_TARGET_RELEASE,
RENDER_TARGET_SETUP,
FRAMEBUFFER_INIT,
FRAMEBUFFER_LOAD,
FRAMEBUFFER_ACTIVATE,
FRAMEBUFFER_MIPMAP,
FRAMEBUFFER_SWAP,
SHADER_INIT,
SHADER_MODEL,
SHADER_LOAD_FILE,
SHADER_LOAD_MEMORY,
SHADER_ACTIVATE,
SHADER_LOCAL,
SHADER_ENVIRONMENT,
TEXTURE_LOAD_EMPTY,
TEXTURE_LOAD_FILE,
TEXTURE_LOAD_MEMORY,
TEXTURE_LOAD_RENDER,
TEXTURE_ACTIVATE,
TEXTURE_PARAMETER,
TEXTURE_MODE,
TEXTURE_MULTI,
TEXTURE_UNIT,
TEXTURE_GET,
DISPLAYLIST_BEGIN,
DISPLAYLIST_END,
DISPLAYLIST_CALL,
FACTOR_SET,
FACTOR_GET,
OBJECT,
POSITION,
RANGE,
MASS,
ENERGY,
SOLID,
INERTION_ADD,
INERTION_RESET,
ANGLE,
FREQUENCY,
FORCE,
RESILIENCE,
SPEED,
COORDS,
DIFFUSION,
MIRROR,
ORIENTATION,
SIZES,
SOUND,
SOUND_ADD,
SOUND_FREE,
SOUND_PLAY,
SOUND_STOP,
SOUND_CLEAN,
MUSIC,
MUSIC_ADD,
MUSIC_FREE,
MUSIC_PLAY,
MUSIC_STOP,
MUSIC_RESET,
MUSIC_REPEAT,
MUSIC_IS_PLAYING,
MUSIC_CLEAN,
VOLUME,
PAN,
LENGTH,
MOUSE,
BUTTON,
KEYBOARD,
CHECK,
PRESSED,
RELEASED,
CLEAR_AFTER,
CLEAR_STATES,
CLEAR,
COMPILE,
NEURON,
DETECTOR,
EFFECTOR,
SEND,
RECEIVE,
LINK,
SHOW_CURSOR,
RENDERQUEUE_PUSH,
RENDERQUEUE_POP,
RENDERQUEUE_SORT,
SURFACES_DRAW,
LOGGER_MODE,
LOGGER_CLEAR,
LOGGER_FLUSH,
COLOR_INDEX,
COLOR_INDEX_ALPHA,
FPS,
DELTA_TIME,
FRAMES,
IS_SUPPORTED,
RENDERLIST,
RENDERLIST_ACTIVATE,
RENDERLIST_UNACTIVATE,
RENDERLIST_IS_ACTIVE,
RENDERLIST_CLEAR,
RENDERLIST_FLUSH,
RENDERLIST_CURRENT_ORDER,
RENDERLIST_FILL_COLOR,
RENDERLIST_FILL_COORDS,
RENDERLIST_FILL_NORMAL,
RENDERLIST_PUSH,
RENDERLIST_POP
};

enum PG_EXTSTATE
{
EXT_AnimationHumanoid
};

typedef double GM_REAL;
typedef char* GM_STRING;

#ifdef PG_PLUGIN
#define PG_FARPROC extern "C" __declspec(dllexport)
#else
#ifdef PG_IMPORT
#define PG_FARPROC extern "C" __declspec(dllimport)
#else
#define PG_FARPROC extern "C" __declspec(dllexport)
#endif /* PG_IMPORT */
#endif /* PG_PLUGIN */

#ifdef PG_PLUGININT
XE_ASSOC<XE_UNI,XE_UNI> pgPluginProcList;
#define PG_PLUGINPROC extern "C" __declspec(dllexport)
#define PG_REGISTER_PLUGIN_PROC(name,count) pgPluginProcList[#name]=count;
#define PG_UNREGISTER_PLUGIN_PROC(name) pgPluginProcList.Erase(name);
typedef void (*PGPLUGINPROC)(XE_UNI,...);
PGPLUGINPROC PG_PluginProc=NULL;
typedef bool (*PGPLUGINPROCLIST)(XE_ASSOC<XE_UNI,XE_UNI>*);
PGPLUGINPROCLIST PG_PluginProcList=NULL;
PG_PLUGINPROC bool PGPLUGINGETPROCLIST(XE_ASSOC<XE_UNI,XE_UNI>* proclist){if(proclist){*proclist=pgPluginProcList;return(true);}else return(false);}
XE_ASSOC <HMODULE,XE_ASSOC<XE_UNI,XE_UNI> > pgPluginList;
#endif /* PG_PLUGININT */

#ifndef PG_PLUGIN

PG_FARPROC GM_REAL pgSystem0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0,GM_REAL a3=0,GM_REAL a4=0,GM_REAL a5=0,GM_REAL a6=0);
PG_FARPROC GM_STRING pgSystem1(GM_REAL cmd,GM_REAL a0=0);
#ifdef XE_COMPILE_PHOTON
PG_FARPROC GM_REAL pgWindow0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0);
PG_FARPROC GM_REAL pgWindow1(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_STRING a2=0);
PG_FARPROC GM_REAL pgPhoton0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0,GM_REAL a3=0,GM_REAL a4=0,GM_REAL a5=0,GM_REAL a6=0);
PG_FARPROC GM_REAL pgPhoton1(GM_REAL cmd,GM_REAL a0=0,GM_STRING a1=0,GM_REAL a2=0);
PG_FARPROC GM_REAL pgPhoton2(GM_REAL cmd,GM_STRING a0=0,GM_REAL a1=0,GM_REAL a2=0);
#endif /* XE_COMPILE_PHOTON */
#ifdef XE_COMPILE_CHAOS
PG_FARPROC GM_REAL pgChaos0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0,GM_REAL a3=0,GM_REAL a4=0,GM_REAL a5=0,GM_REAL a6=0);
#endif /* XE_COMPILE_CHAOS */
PG_FARPROC GM_REAL pgEcho0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0,GM_REAL a3=0);
PG_FARPROC GM_REAL pgEcho1(GM_REAL cmd,GM_STRING a0=0);
PG_FARPROC GM_REAL pgData0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0);
PG_FARPROC GM_REAL pgData1(GM_REAL cmd,GM_REAL a0=0,GM_STRING a1=0);
PG_FARPROC GM_REAL pgData2(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_STRING a2=0);
PG_FARPROC GM_REAL pgMath0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0,GM_REAL a3=0,GM_REAL a4=0,GM_REAL a5=0,GM_REAL a6=0,GM_REAL a7=0);
#ifdef XE_COMPILE_PHOTON
PG_FARPROC GM_REAL pgInterface0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0,GM_REAL a3=0);
#endif /* XE_COMPILE_PHOTON */
#ifdef XE_COMPILE_PSYCHE
PG_FARPROC GM_REAL pgPsyche0(GM_REAL cmd,GM_REAL a0=0,GM_REAL a1=0,GM_REAL a2=0,GM_REAL a3=0,GM_REAL a4=0);
PG_FARPROC GM_REAL pgPsyche1(GM_REAL cmd,GM_REAL a0=0,GM_STRING a1=0);
#endif /* XE_COMPILE_PSYCHE */
PG_FARPROC GM_STRING pgGetModules0();
PG_FARPROC GM_STRING pgGetExtensions0();

#endif /* PG_PLUGIN */

#ifdef PG_PLUGIN

typedef GM_REAL (*T_System0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_System0 pgSystem0=NULL;
typedef GM_STRING (*T_System1)(GM_REAL,GM_REAL);
T_System1 pgSystem1=NULL;
#ifdef XE_COMPILE_PHOTON
typedef GM_REAL (*T_Window0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_Window0 pgWindow0=NULL;
typedef GM_REAL (*T_Window1)(GM_REAL,GM_REAL,GM_REAL,GM_STRING);
T_Window1 pgWindow1=NULL;
typedef GM_REAL (*T_Photon0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_Photon0 pgPhoton0=NULL;
typedef GM_REAL (*T_Photon1)(GM_REAL,GM_REAL,GM_STRING,GM_REAL);
T_Photon1 pgPhoton1=NULL;
typedef GM_REAL (*T_Photon2)(GM_REAL,GM_STRING,GM_REAL,GM_REAL);
T_Photon2 pgPhoton2=NULL;
#endif /* XE_COMPILE_PHOTON */
#ifdef XE_COMPILE_CHAOS
typedef GM_REAL (*T_Chaos0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_Chaos0 pgChaos0=NULL;
#endif /* XE_COMPILE_CHAOS */
typedef GM_REAL (*T_Echo0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_Echo0 pgEcho0=NULL;
typedef GM_REAL (*T_Echo1)(GM_REAL,GM_STRING);
T_Echo1 pgEcho1=NULL;
typedef GM_REAL (*T_Data0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_Data0 pgData0=NULL;
typedef GM_REAL (*T_Data1)(GM_REAL,GM_REAL,GM_STRING);
T_Data1 pgData1=NULL;
typedef GM_REAL (*T_Data2)(GM_REAL,GM_REAL,GM_REAL,GM_STRING);
T_Data2 pgData2=NULL;
typedef GM_REAL (*T_Math0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_Math0 pgMath0=NULL;
#ifdef XE_COMPILE_PHOTON
typedef GM_REAL (*T_Interface0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_Interface0 pgInterface0=NULL;
#endif /* XE_COMPILE_PHOTON */
#ifdef XE_COMPILE_PSYCHE
typedef GM_REAL (*T_Psyche0)(GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL,GM_REAL);
T_Psyche0 pgPsyche0=NULL;
typedef GM_REAL (*T_Psyche1)(GM_REAL,GM_REAL,GM_STRING);
T_Psyche1 pgPsyche1=NULL;
#endif /* XE_COMPILE_PSYCHE */
typedef GM_STRING (*T_GetModules0)(void);
T_GetModules0 pgGetModules0=NULL;
typedef GM_STRING (*T_GetExtensions0)(void);
T_GetExtensions0 pgGetExtensions0=NULL;

#endif /* PG_PLUGIN */

class PLAYGATE
{
public:
	PLAYGATE();
	XE_UNI System	(PG_ESTATE cmd,XE_UNI a0=(GM_REAL)0,XE_UNI a1=(GM_REAL)0,XE_UNI a2=(GM_REAL)0,XE_UNI a3=(GM_REAL)0,XE_UNI a4=(GM_REAL)0,XE_UNI a5=(GM_REAL)0,XE_UNI a6=(GM_REAL)0);
	#ifdef XE_COMPILE_PHOTON
	XE_UNI Window	(PG_ESTATE cmd,XE_UNI a0=(GM_REAL)0,XE_UNI a1=(GM_REAL)0,XE_UNI a2=(GM_REAL)0);
	XE_UNI Photon	(PG_ESTATE cmd,XE_UNI a0=(GM_REAL)0,XE_UNI a1=(GM_REAL)0,XE_UNI a2=(GM_REAL)0,XE_UNI a3=(GM_REAL)0,XE_UNI a4=(GM_REAL)0,XE_UNI a5=(GM_REAL)0,XE_UNI a6=(GM_REAL)0);
	#endif /* XE_COMPILE_PHOTON */
	#ifdef XE_COMPILE_CHAOS
	XE_UNI Chaos	(PG_ESTATE cmd,XE_UNI a0=(GM_REAL)0,XE_UNI a1=(GM_REAL)0,XE_UNI a2=(GM_REAL)0,XE_UNI a3=(GM_REAL)0,XE_UNI a4=(GM_REAL)0,XE_UNI a5=(GM_REAL)0,XE_UNI a6=(GM_REAL)0);
	#endif /* XE_COMPILE_CHAOS */
	XE_UNI Echo		(PG_ESTATE cmd,XE_UNI a0=(GM_REAL)0,XE_UNI a1=(GM_REAL)0,XE_UNI a2=(GM_REAL)0,XE_UNI a3=(GM_REAL)0);
	XE_UNI Data		(PG_ESTATE cmd,XE_UNI a0=(GM_REAL)0,XE_UNI a1=(GM_REAL)0,XE_UNI a2=(GM_REAL)0);
	XE_UNI Math		(PG_ESTATE cmd,XE_UNI a0=(GM_REAL)0,XE_UNI a1=(GM_REAL)0,XE_UNI a2=(GM_REAL)0,XE_UNI a3=(GM_REAL)0,XE_UNI a4=(GM_REAL)0,XE_UNI a5=(GM_REAL)0,XE_UNI a6=(GM_REAL)0,XE_UNI a7=(GM_REAL)0);
	#ifdef XE_COMPILE_PHOTON
	XE_UNI Interface(PG_ESTATE cmd,XE_UNI a0=(GM_REAL)0,XE_UNI a1=(GM_REAL)0,XE_UNI a2=(GM_REAL)0,XE_UNI a3=(GM_REAL)0);
	#endif /* XE_COMPILE_PHOTON */
	XE_UNI GetModules();
	XE_UNI GetExtensions();
};

PLAYGATE::PLAYGATE()
{
#ifdef PG_PLUGIN
	HMODULE module=GetModuleHandle("XenoN PlayGate.dll");
	if(module)
	{
		pgSystem0=(T_System0)GetProcAddress(module,"pgSystem0");
		pgSystem1=(T_System1)GetProcAddress(module,"pgSystem1");
		#ifdef XE_COMPILE_PHOTON
		pgWindow0=(T_Window0)GetProcAddress(module,"pgWindow0");
		pgWindow1=(T_Window1)GetProcAddress(module,"pgWindow1");
		pgPhoton0=(T_Photon0)GetProcAddress(module,"pgPhoton0");
		pgPhoton1=(T_Photon1)GetProcAddress(module,"pgPhoton1");
		pgPhoton2=(T_Photon2)GetProcAddress(module,"pgPhoton2");
		#endif /* XE_COMPILE_PHOTON */
		#ifdef XE_COMPILE_CHAOS
		pgChaos0=(T_Chaos0)GetProcAddress(module,"pgChaos0");
		#endif /* XE_COMPILE_CHAOS */
		pgEcho0=(T_Echo0)GetProcAddress(module,"pgEcho0");
		pgEcho1=(T_Echo1)GetProcAddress(module,"pgEcho1");
		pgData0=(T_Data0)GetProcAddress(module,"pgData0");
		pgData1=(T_Data1)GetProcAddress(module,"pgData1");
		pgData2=(T_Data2)GetProcAddress(module,"pgData2");
		pgMath0=(T_Math0)GetProcAddress(module,"pgMath0");
		#ifdef XE_COMPILE_PHOTON
		pgInterface0=(T_Interface0)GetProcAddress(module,"pgInterface0");
		#endif /* XE_COMPILE_PHOTON */
		pgGetModules0=(T_GetModules0)GetProcAddress(module,"pgGetModules0");
		pgGetExtensions0=(T_GetExtensions0)GetProcAddress(module,"pgGetExtensions0");
	}
	else
		MessageBox(NULL,"Cannot Find PlayGate Module!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
#endif /* PG_PLUGIN */
}

XE_UNI PLAYGATE::System	(PG_ESTATE cmd, XE_UNI a0, XE_UNI a1, XE_UNI a2, XE_UNI a3, XE_UNI a4, XE_UNI a5, XE_UNI a6)
{
	if(	cmd==PREPARE_TO_BE	||
		cmd==INITIATION		||
		cmd==CLOSURE		||
		cmd==GET			||
		cmd==SET			||
		cmd==LOGGER_MODE	||
		cmd==LOGGER_CLEAR	||
		cmd==LOGGER_FLUSH	||
		cmd==IS_SUPPORTED	)
		if(pgSystem0!=NULL)
		return(pgSystem0((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_REAL)a2,(GM_REAL)a3,(GM_REAL)a4,(GM_REAL)a5,(GM_REAL)a6));
	if(	cmd==INFO	)
		if(pgSystem1!=NULL)
		return(pgSystem1((GM_REAL)(int)cmd,(GM_REAL)a0));
	MessageBox(NULL,"Wrong PlayGate State Variable!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
	return((GM_REAL)0);
}

#ifdef XE_COMPILE_PHOTON

XE_UNI PLAYGATE::Window	(PG_ESTATE cmd,XE_UNI a0,XE_UNI a1,XE_UNI a2)
{
	if(	cmd==CREATE_ELM				||
		cmd==DESTROY_ELM			||
		cmd==SET					||
		cmd==GET					||
		cmd==CREATE					||
		cmd==DESTROY				||
		cmd==UPDATE					||
		cmd==RENDER_TARGET_ACTIVATE	||
		cmd==SHOW					||
		cmd==SHOW_CURSOR			)
		if(pgWindow0!=NULL)
		return(pgWindow0((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_REAL)a2));
	if(	cmd==SET	)
		if(a0==NAME)
			if(pgWindow1!=NULL)
			return(pgWindow1((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_STRING)a2));
	MessageBox(NULL,"Wrong PlayGate State Variable!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
	return((GM_REAL)0);
}

XE_UNI PLAYGATE::Photon	(PG_ESTATE cmd,XE_UNI a0,XE_UNI a1,XE_UNI a2,XE_UNI a3,XE_UNI a4,XE_UNI a5,XE_UNI a6)
{
	if(	cmd==COLOR					||
		cmd==VIEWPORT				||
		cmd==UPDATE					||
		cmd==VSYNC					||
		cmd==PRIMITIVE_BEGIN		||
		cmd==PRIMITIVE_END			||
		cmd==PUT					||
		cmd==CREATE_ELM				||
		cmd==DESTROY_ELM			||
		cmd==RENDER_TARGET_ACTIVATE	||
		cmd==RENDER_TARGET_RELEASE	||
		cmd==RENDER_TARGET_SETUP	||
		cmd==FRAMEBUFFER_INIT		||
		cmd==FRAMEBUFFER_ACTIVATE	||
		cmd==FRAMEBUFFER_MIPMAP		||
		cmd==FRAMEBUFFER_SWAP		||
		cmd==SHADER_INIT			||
		cmd==SHADER_MODEL			||
		cmd==SHADER_LOAD_MEMORY		||
		cmd==SHADER_ACTIVATE		||
		cmd==SHADER_LOCAL			||
		cmd==SHADER_ENVIRONMENT		||
		cmd==TEXTURE_LOAD_EMPTY		||
		cmd==TEXTURE_LOAD_MEMORY	||
		cmd==TEXTURE_LOAD_RENDER	||
		cmd==TEXTURE_ACTIVATE		||
		cmd==TEXTURE_PARAMETER		||
		cmd==TEXTURE_MODE			||
		cmd==TEXTURE_MULTI			||
		cmd==TEXTURE_UNIT			||
		cmd==TEXTURE_GET			||
		cmd==DISPLAYLIST_BEGIN		||
		cmd==DISPLAYLIST_END		||
		cmd==DISPLAYLIST_CALL		||
		cmd==SET					||
		cmd==GET					||
		cmd==SPRITE_DRAW			||
		cmd==RENDERQUEUE_PUSH		||
		cmd==RENDERQUEUE_POP		||
		cmd==RENDERQUEUE_SORT		||
		cmd==SURFACES_DRAW			||
		cmd==MATRIX_MODE			||
		cmd==MATRIX_IDENTITY		||
		cmd==MATRIX_PUSH			||
		cmd==MATRIX_POP				||
		cmd==MATRIX_ROTATE			||
		cmd==MATRIX_SCALE			||
		cmd==MATRIX_TRANSLATE		||
		cmd==MATRIX_LOAD			||
		cmd==MATRIX_GET				||
		cmd==RENDERLIST_ACTIVATE	||
		cmd==RENDERLIST_UNACTIVATE	||
		cmd==RENDERLIST_IS_ACTIVE	||
		cmd==RENDERLIST_CLEAR		||
		cmd==RENDERLIST_FLUSH		||
		cmd==RENDERLIST_PUSH		||
		cmd==RENDERLIST_POP			||
		cmd==COLOR_INDEX			||
		cmd==COLOR_INDEX_ALPHA		||
		cmd==PREPARE_FONT			||
		cmd==ACTIVATE_FONT			)
		if(pgPhoton0!=NULL)
		return(pgPhoton0((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_REAL)a2,(GM_REAL)a3,(GM_REAL)a4,(GM_REAL)a5,(GM_REAL)a6));
	if(	cmd==SHADER_LOAD_FILE	||
		cmd==TEXTURE_LOAD_FILE	||
		cmd==GENERATE_FONT		)
		if(pgPhoton1!=NULL)
		return(pgPhoton1((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_STRING)a1,(GM_REAL)a2));
	if(	cmd==TEXT	)
		if(pgPhoton2!=NULL)
		return(pgPhoton2((GM_REAL)(int)cmd,(GM_STRING)a0,(GM_REAL)a1,(GM_REAL)a2));
	MessageBox(NULL,"Wrong PlayGate State Variable!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
	return((GM_REAL)0);
}

#endif /* XE_COMPILE_PHOTON */

#ifdef XE_COMPILE_CHAOS

XE_UNI PLAYGATE::Chaos	(PG_ESTATE cmd,XE_UNI a0,XE_UNI a1,XE_UNI a2,XE_UNI a3,XE_UNI a4,XE_UNI a5,XE_UNI a6)
{
	if(	cmd==CREATE_ELM			||
		cmd==DESTROY_ELM		||
		cmd==FACTOR_GET			||
		cmd==FACTOR_SET			||
		cmd==UPDATE				||
		cmd==SET				||
		cmd==GET				)
		if(pgChaos0!=NULL)
		return(pgChaos0((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_REAL)a2,(GM_REAL)a3,(GM_REAL)a4,(GM_REAL)a5,(GM_REAL)a6));
	MessageBox(NULL,"Wrong PlayGate State Variable!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
	return((GM_REAL)0);
}

#endif /* XE_COMPILE_CHAOS */

XE_UNI PLAYGATE::Echo	(PG_ESTATE cmd,XE_UNI a0,XE_UNI a1,XE_UNI a2,XE_UNI a3)
{
	if(	cmd==SOUND_FREE			||
		cmd==MUSIC_FREE			||
		cmd==SOUND_PLAY			||
		cmd==MUSIC_PLAY			||
		cmd==SOUND_STOP			||
		cmd==MUSIC_STOP			||
		cmd==SOUND_CLEAN		||
		cmd==MUSIC_CLEAN		||
		cmd==MUSIC_RESET		||
		cmd==MUSIC_REPEAT		||
		cmd==MUSIC_IS_PLAYING	||
		cmd==SET				||
		cmd==GET				)
		if(pgEcho0!=NULL)
		return(pgEcho0((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_REAL)a2,(GM_REAL)a3));
	if(	cmd==SOUND_ADD	||
		cmd==MUSIC_ADD	)
		if(pgEcho1!=NULL)
		return(pgEcho1((GM_REAL)(int)cmd,(GM_STRING)a0));
	MessageBox(NULL,"Wrong PlayGate State Variable!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
	return((GM_REAL)0);
}

XE_UNI PLAYGATE::Data	(PG_ESTATE cmd,XE_UNI a0,XE_UNI a1,XE_UNI a2)
{
	if(	cmd==CREATE_ELM				||
		cmd==DESTROY_ELM			||
		cmd==RESOURCE_LOAD_PLAYGATE	||
		cmd==RESOURCE_BUFFER		||
		cmd==RESOURCE_FREE			||
		cmd==BUFFER_ALLOC			||
		cmd==BUFFER_RELEASE			||
		cmd==BUFFER_SIZE			||
		cmd==BUFFER_POINTER			||
		cmd==SET					||
		cmd==GET					||
		cmd==SIZEOF					)
		if(pgData0!=NULL)
		return(pgData0((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_REAL)a2));
	if(	cmd==RESOURCE_LOAD_FILE	)
		if(pgData1!=NULL)
		return(pgData1((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_STRING)a1));
	if(	cmd==ENCODE	||
		cmd==DECODE	||
		cmd==PACK	||
		cmd==UNPACK	)
		if(pgData2!=NULL)
		return(pgData2((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_STRING)a2));
	MessageBox(NULL,"Wrong PlayGate State Variable!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
	return((GM_REAL)0);
}

XE_UNI PLAYGATE::Math	(PG_ESTATE cmd,XE_UNI a0,XE_UNI a1,XE_UNI a2,XE_UNI a3,XE_UNI a4,XE_UNI a5,XE_UNI a6,XE_UNI a7)
{
	if(	cmd==CREATE_ELM			||
		cmd==DESTROY_ELM		||
		cmd==MATRIX_PUSH		||
		cmd==MATRIX_POP			||
		cmd==MATRIX_SET			||
		cmd==MATRIX_GET			||
		cmd==MATRIX_IDENTITY	||
		cmd==MATRIX_MULTIPLY	||
		cmd==MATRIX_ROTATE		||
		cmd==MATRIX_SCALE		||
		cmd==MATRIX_TRANSLATE	||
		cmd==MATRIX_TRANSPOSE	||
		cmd==VECTOR_PUSH		||
		cmd==VECTOR_POP			||
		cmd==VECTOR_SET			||
		cmd==VECTOR_GET			||
		cmd==VECTOR_ADD			||
		cmd==VECTOR_SUB			||
		cmd==VECTOR_MUL			||
		cmd==VECTOR_DIV			||
		cmd==LENGTHDIR_X		||
		cmd==LENGTHDIR_Y		||
		cmd==LENGTHDIR_Z		||
		cmd==DIRECTION_ALPHA	||
		cmd==DIRECTION_BETA		||
		cmd==DISTANCE			||
		cmd==CAMERA_PERSPECTIVE	||
		cmd==CAMERA_ORTHO		||
		cmd==CAMERA_TO_ORTHO	||
		cmd==CAMERA_GET			||
		cmd==CROSS_PRODUCT_X	||
		cmd==CROSS_PRODUCT_Y	||
		cmd==CROSS_PRODUCT_Z	||
		cmd==DOT_PRODUCT		||
		cmd==CURVE				)
		if(pgMath0!=NULL)
		return(pgMath0((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_REAL)a2,(GM_REAL)a3,(GM_REAL)a4,(GM_REAL)a5,(GM_REAL)a6,(GM_REAL)a7));
	MessageBox(NULL,"Wrong PlayGate State Variable!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
	return((GM_REAL)0);
}

#ifdef XE_COMPILE_PHOTON

XE_UNI PLAYGATE::Interface(PG_ESTATE cmd,XE_UNI a0,XE_UNI a1,XE_UNI a2,XE_UNI a3)
{
	if(	cmd==CLEAR_STATES	||
		cmd==UPDATE			||
		cmd==CLEAR_AFTER	||
		cmd==GET			||
		cmd==SET			)
		if(pgInterface0!=NULL)
		return(pgInterface0((GM_REAL)(int)cmd,(GM_REAL)a0,(GM_REAL)a1,(GM_REAL)a2,(GM_REAL)a3));
	MessageBox(NULL,"Wrong PlayGate State Variable!","XenoN PlayGate Plugin Error",MB_OK+MB_ICONERROR);
	return((GM_REAL)0);
}

#endif /* XE_COMPILE_PHOTON */

XE_UNI PLAYGATE::GetModules()
{
	if(pgGetModules0!=NULL)
	return(pgGetModules0());
}

XE_UNI PLAYGATE::GetExtensions()
{
	if(pgGetExtensions0!=NULL)
	return(pgGetExtensions0());
}
